<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: Factory.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Factory.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Factory_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef FACTORY_HPP</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define FACTORY_HPP</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;QHash&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;QString&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">//#include &quot;Context.hpp&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">//#include &quot;MeasurementState.hpp&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="parms_8hpp.html">parms.hpp</a>&quot;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">class </span><a class="code" href="classExperiment.html">Experiment</a>;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="code" href="structProtocol.html">   19</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structProtocol.html">Protocol</a></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;  <a class="code" href="structProtocol.html#aad2c8b699e975c093b0e18636171f863">Protocol</a>(<a class="code" href="classExperiment.html">Experiment</a>&amp; <a class="code" href="structProtocol.html#a67ea1f74c54d7f7445dc16ae88d28934">experiment</a>);</div>
<div class="line"><a name="l00030"></a><span class="lineno"><a class="code" href="structProtocol.html#a5d9b6d6140081f8a99d30fa56448eb1d">   30</a></span>&#160;  <span class="keyword">virtual</span> <a class="code" href="structProtocol.html#a5d9b6d6140081f8a99d30fa56448eb1d">~Protocol</a>() { };</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structProtocol.html#a7ab9aea5ae5e4935cd9e4489cf4c7b8a">run</a>() = 0;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;  <span class="comment">//virtual void run(Context&amp; context) = 0;</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structProtocol.html#a6cf60ddf14537059a5b49550b601fdba">readParameters</a>(<span class="keyword">const</span> <a class="code" href="classParms.html" title="A utility class to parse L-Studio like parameter files.">Parms</a>&amp; parms) = 0;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structProtocol.html#a52110f851961c9a77bf93586cb7ed751">writeParameters</a>(<a class="code" href="classParms.html" title="A utility class to parse L-Studio like parameter files.">Parms</a>&amp; parms) <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  </div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="code" href="structProtocol.html#a67ea1f74c54d7f7445dc16ae88d28934">   50</a></span>&#160;  <a class="code" href="classExperiment.html">Experiment</a>&amp; <a class="code" href="structProtocol.html#a67ea1f74c54d7f7445dc16ae88d28934">experiment</a>()<span class="keyword"> const</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">  </span>{</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;      <span class="keywordflow">return</span> <a class="code" href="structProtocol.html#a2e08bdeab5b8999e9cb167a413a9da3d">_experiment</a>;</div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="code" href="structProtocol.html#a2e08bdeab5b8999e9cb167a413a9da3d">   53</a></span>&#160;  };</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <a class="code" href="classExperiment.html">Experiment</a>&amp; <a class="code" href="structProtocol.html#a2e08bdeab5b8999e9cb167a413a9da3d">_experiment</a>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;};</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="code" href="Factory_8hpp.html#ac382ea009b4d4cfc84e9bde8ea23392e">   59</a></span>&#160;<span class="keyword">typedef</span> std::shared_ptr&lt;Protocol&gt; <a class="code" href="Factory_8hpp.html#ac382ea009b4d4cfc84e9bde8ea23392e">ProtocolPtr</a>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="code" href="structProtocolMaker.html">   67</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structProtocolMaker.html">ProtocolMaker</a></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;{</div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="code" href="structProtocolMaker.html#a6368942c99e41cad195d9d854176dbe1">   69</a></span>&#160;  <span class="keyword">virtual</span> <a class="code" href="structProtocolMaker.html#a6368942c99e41cad195d9d854176dbe1">~ProtocolMaker</a>() { }</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="keyword">virtual</span> std::shared_ptr&lt;Protocol&gt; <a class="code" href="structProtocolMaker.html#abef230c37ae8eba7f0c8a8e3d27c6ecd">create</a>(<a class="code" href="classExperiment.html">Experiment</a>&amp; experiment) = 0;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;};</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00079"></a><span class="lineno"><a class="code" href="classFactory.html">   79</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFactory.html">Factory</a></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;{</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;  <a class="code" href="classFactory.html#ac792bf88cfb7b6804b479529da5308cc">Factory</a>();</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  <a class="code" href="classFactory.html#ac792bf88cfb7b6804b479529da5308cc">Factory</a>(<span class="keyword">const</span> <a class="code" href="classFactory.html">Factory</a>&amp; copy);</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno"><a class="code" href="classFactory.html#a7c27626c281e8d2223344391a7867524">   94</a></span>&#160;  QHash&lt;QString, std::shared_ptr&lt;ProtocolMaker&gt; &gt; <a class="code" href="classFactory.html#a7c27626c281e8d2223344391a7867524">protocoles</a>;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;  <span class="keyword">static</span> <a class="code" href="classFactory.html">Factory</a>&amp; <a class="code" href="classFactory.html#aa3472cb7ee0cf2a3368b9127a6dba236">instance</a>();</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classFactory.html#a4afdb23e17512b236a563707beb7c2b7">register_protocol</a>(QString name, std::shared_ptr&lt;ProtocolMaker&gt; proc);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classFactory.html#a3ce9afdf669ae1f9a4dd9b9a9af45cd9">unregister_protocol</a>(QString name, std::shared_ptr&lt;ProtocolMaker&gt; proc);</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;  std::shared_ptr&lt;Protocol&gt; <a class="code" href="classFactory.html#aecc4c03b2954c223b8596f5a5f61ee7b">protocol</a>(QString name, <a class="code" href="classExperiment.html">Experiment</a>&amp; experiment);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;};</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div>
<div class="line"><a name="l00129"></a><span class="lineno"><a class="code" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9">  129</a></span>&#160;<span class="keyword">inline</span> <a class="code" href="classFactory.html">Factory</a>&amp; <a class="code" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9">factory</a>() { <span class="keywordflow">return</span> <a class="code" href="classFactory.html#aa3472cb7ee0cf2a3368b9127a6dba236">Factory::instance</a>(); }</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> P&gt;</div>
<div class="line"><a name="l00136"></a><span class="lineno"><a class="code" href="structTypedProtocolMaker.html">  136</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structTypedProtocolMaker.html">TypedProtocolMaker</a> : <span class="keyword">public</span> <a class="code" href="structProtocolMaker.html">ProtocolMaker</a></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;{</div>
<div class="line"><a name="l00141"></a><span class="lineno"><a class="code" href="structTypedProtocolMaker.html#a8142cbe40d93ba1f5b3d61037b3bccdf">  141</a></span>&#160;  <span class="keyword">virtual</span> std::shared_ptr&lt;Protocol&gt; <a class="code" href="structTypedProtocolMaker.html#a8142cbe40d93ba1f5b3d61037b3bccdf">create</a>(<a class="code" href="classExperiment.html">Experiment</a>&amp; experiment) { <span class="keywordflow">return</span> std::make_shared&lt;P&gt;(experiment); }</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;};</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> P&gt;</div>
<div class="line"><a name="l00150"></a><span class="lineno"><a class="code" href="structProtocolRegistration.html">  150</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structProtocolRegistration.html">ProtocolRegistration</a></div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;{</div>
<div class="line"><a name="l00155"></a><span class="lineno"><a class="code" href="structProtocolRegistration.html#acb1944dd4c3f0742db6f5f109567f841">  155</a></span>&#160;  <span class="keyword">typedef</span> P <a class="code" href="structProtocolRegistration.html#acb1944dd4c3f0742db6f5f109567f841">ProtocolType</a>;</div>
<div class="line"><a name="l00159"></a><span class="lineno"><a class="code" href="structProtocolRegistration.html#af577017ca43a06ff5b55c7013902731d">  159</a></span>&#160;  <span class="keyword">typedef</span> <a class="code" href="structTypedProtocolMaker.html">TypedProtocolMaker&lt;P&gt;</a> <a class="code" href="structProtocolRegistration.html#af577017ca43a06ff5b55c7013902731d">Maker</a>;</div>
<div class="line"><a name="l00163"></a><span class="lineno"><a class="code" href="structProtocolRegistration.html#a53abeba6877c206afb32d35cfbe63ca4">  163</a></span>&#160;  QString <a class="code" href="structProtocolRegistration.html#a53abeba6877c206afb32d35cfbe63ca4">name</a>;</div>
<div class="line"><a name="l00167"></a><span class="lineno"><a class="code" href="structProtocolRegistration.html#a7748bd3c1e9efdf353eac2651a6ed9c7">  167</a></span>&#160;  std::shared_ptr&lt;Maker&gt; <a class="code" href="structProtocolRegistration.html#a7748bd3c1e9efdf353eac2651a6ed9c7">maker</a>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno"><a class="code" href="structProtocolRegistration.html#ad14be68e5a3a949a135f869c545ef007">  174</a></span>&#160;  <a class="code" href="structProtocolRegistration.html#ad14be68e5a3a949a135f869c545ef007">ProtocolRegistration</a>(QString n)</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    : <a class="code" href="structProtocolRegistration.html#a53abeba6877c206afb32d35cfbe63ca4">name</a>(n)</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    , <a class="code" href="structProtocolRegistration.html#a7748bd3c1e9efdf353eac2651a6ed9c7">maker</a>(std::make_shared&lt;<a class="code" href="structTypedProtocolMaker.html">Maker</a>&gt;())</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;  {</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="keywordflow">if</span>(!<a class="code" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9">factory</a>().register_protocol(<a class="code" href="structProtocolRegistration.html#a53abeba6877c206afb32d35cfbe63ca4">name</a>, <a class="code" href="structProtocolRegistration.html#a7748bd3c1e9efdf353eac2651a6ed9c7">maker</a>))</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;      ::abort();</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;  }</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div>
<div class="line"><a name="l00187"></a><span class="lineno"><a class="code" href="structProtocolRegistration.html#ad7b35e71798516005186500959c3f0fa">  187</a></span>&#160;  <a class="code" href="structProtocolRegistration.html#ad7b35e71798516005186500959c3f0fa">~ProtocolRegistration</a>()</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;  {</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordflow">if</span>(!<a class="code" href="Factory_8hpp.html#a260e511783256d65c1e55ed23434f7c9">factory</a>().unregister_protocol(<a class="code" href="structProtocolRegistration.html#a53abeba6877c206afb32d35cfbe63ca4">name</a>, <a class="code" href="structProtocolRegistration.html#a7748bd3c1e9efdf353eac2651a6ed9c7">maker</a>))</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;      ::abort();</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;  }</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;};</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div>
<div class="line"><a name="l00199"></a><span class="lineno"><a class="code" href="Factory_8hpp.html#a01212122f1b1e69221a16e96d549683a">  199</a></span>&#160;<span class="preprocessor">#define REGISTER_PROTOCOL(name, ProtocolClass) \</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="preprocessor">  ProtocolRegistration&lt;ProtocolClass&gt; ProtocolClass##_registration(name)</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="preprocessor">#endif // FACTORY_HPP</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;<span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
